"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createAutoField = void 0;
const tslib_1 = require("tslib");
const invariant_1 = tslib_1.__importDefault(require("invariant"));
const react_1 = require("react");
const useField_1 = require("./useField");
function createAutoField(defaultComponentDetector) {
    const context = react_1.createContext(defaultComponentDetector);
    function AutoField(rawProps) {
        var _a;
        const [props, uniforms] = useField_1.useField(rawProps.name, rawProps);
        const componentDetector = react_1.useContext(context);
        const component = componentDetector(props, uniforms);
        invariant_1.default(component, 'AutoField received no component for: %s', props.name);
        return 'options' in component && ((_a = component.options) === null || _a === void 0 ? void 0 : _a.kind) === 'leaf'
            ? react_1.createElement(component.Component, props)
            : react_1.createElement(component, rawProps);
    }
    return Object.assign(AutoField, {
        componentDetectorContext: context,
        defaultComponentDetector,
    });
}
exports.createAutoField = createAutoField;
